// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/RegionOfInterest3D.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/region_of_interest3_d__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `id`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"
// Member `primitive`
#include "shape_msgs/msg/detail/solid_primitive__functions.h"

bool
rc_reason_msgs__msg__RegionOfInterest3D__init(rc_reason_msgs__msg__RegionOfInterest3D * msg)
{
  if (!msg) {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    rc_reason_msgs__msg__RegionOfInterest3D__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__RegionOfInterest3D__fini(msg);
    return false;
  }
  // primitive
  if (!shape_msgs__msg__SolidPrimitive__init(&msg->primitive)) {
    rc_reason_msgs__msg__RegionOfInterest3D__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__RegionOfInterest3D__fini(rc_reason_msgs__msg__RegionOfInterest3D * msg)
{
  if (!msg) {
    return;
  }
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // primitive
  shape_msgs__msg__SolidPrimitive__fini(&msg->primitive);
}

rc_reason_msgs__msg__RegionOfInterest3D *
rc_reason_msgs__msg__RegionOfInterest3D__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__RegionOfInterest3D * msg = (rc_reason_msgs__msg__RegionOfInterest3D *)allocator.allocate(sizeof(rc_reason_msgs__msg__RegionOfInterest3D), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__RegionOfInterest3D));
  bool success = rc_reason_msgs__msg__RegionOfInterest3D__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__RegionOfInterest3D__destroy(rc_reason_msgs__msg__RegionOfInterest3D * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__RegionOfInterest3D__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__RegionOfInterest3D__Sequence__init(rc_reason_msgs__msg__RegionOfInterest3D__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__RegionOfInterest3D * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__RegionOfInterest3D *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__RegionOfInterest3D), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__RegionOfInterest3D__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__RegionOfInterest3D__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__RegionOfInterest3D__Sequence__fini(rc_reason_msgs__msg__RegionOfInterest3D__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__RegionOfInterest3D__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__RegionOfInterest3D__Sequence *
rc_reason_msgs__msg__RegionOfInterest3D__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__RegionOfInterest3D__Sequence * array = (rc_reason_msgs__msg__RegionOfInterest3D__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__RegionOfInterest3D__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__RegionOfInterest3D__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__RegionOfInterest3D__Sequence__destroy(rc_reason_msgs__msg__RegionOfInterest3D__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__RegionOfInterest3D__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
