// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/SetHandEyeCalibration.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/set_hand_eye_calibration__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
rc_reason_msgs__srv__SetHandEyeCalibration_Request__init(rc_reason_msgs__srv__SetHandEyeCalibration_Request * msg)
{
  if (!msg) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    rc_reason_msgs__srv__SetHandEyeCalibration_Request__fini(msg);
    return false;
  }
  // robot_mounted
  return true;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Request__fini(rc_reason_msgs__srv__SetHandEyeCalibration_Request * msg)
{
  if (!msg) {
    return;
  }
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // robot_mounted
}

rc_reason_msgs__srv__SetHandEyeCalibration_Request *
rc_reason_msgs__srv__SetHandEyeCalibration_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SetHandEyeCalibration_Request * msg = (rc_reason_msgs__srv__SetHandEyeCalibration_Request *)allocator.allocate(sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Request));
  bool success = rc_reason_msgs__srv__SetHandEyeCalibration_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Request__destroy(rc_reason_msgs__srv__SetHandEyeCalibration_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__SetHandEyeCalibration_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence__init(rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SetHandEyeCalibration_Request * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__SetHandEyeCalibration_Request *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__SetHandEyeCalibration_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__SetHandEyeCalibration_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence__fini(rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__SetHandEyeCalibration_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence *
rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence * array = (rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence__destroy(rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}


// Include directives for member types
// Member `message`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__srv__SetHandEyeCalibration_Response__init(rc_reason_msgs__srv__SetHandEyeCalibration_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // status
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    rc_reason_msgs__srv__SetHandEyeCalibration_Response__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Response__fini(rc_reason_msgs__srv__SetHandEyeCalibration_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // status
  // message
  rosidl_runtime_c__String__fini(&msg->message);
}

rc_reason_msgs__srv__SetHandEyeCalibration_Response *
rc_reason_msgs__srv__SetHandEyeCalibration_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SetHandEyeCalibration_Response * msg = (rc_reason_msgs__srv__SetHandEyeCalibration_Response *)allocator.allocate(sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Response));
  bool success = rc_reason_msgs__srv__SetHandEyeCalibration_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Response__destroy(rc_reason_msgs__srv__SetHandEyeCalibration_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__SetHandEyeCalibration_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence__init(rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SetHandEyeCalibration_Response * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__SetHandEyeCalibration_Response *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__SetHandEyeCalibration_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__SetHandEyeCalibration_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence__fini(rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__SetHandEyeCalibration_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence *
rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence * array = (rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence__destroy(rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
